import 'dart:io';
import 'dart:typed_data';

import 'package:at_persistence_secondary_server/at_persistence_secondary_server.dart';
import 'package:at_utils/at_utils.dart';
import 'package:hive/hive.dart';

void main() async {
  final atSign = '@hello';
  var _boxName= AtUtils.getShaForAtSign(atSign);
  print('$_boxName');
  final storagePath = '/home/murali/work/2021/@/prod_hive_issue/test';
  Hive.init(storagePath);
  if (!Hive.isAdapterRegistered(AtDataAdapter().typeId)) {
    Hive.registerAdapter(AtDataAdapter());
  }
  if (!Hive.isAdapterRegistered(AtMetaDataAdapter().typeId)) {
    Hive.registerAdapter(AtMetaDataAdapter());
  }
  if (!Hive.isAdapterRegistered(CommitEntryAdapter().typeId)) {
    Hive.registerAdapter(CommitEntryAdapter());
  }
  if (!Hive.isAdapterRegistered(CommitOpAdapter().typeId)) {
    Hive.registerAdapter(CommitOpAdapter());
  }
//  final secretString = File('$storagePath/$_boxName.hash').readAsStringSync();
//  final secret = Uint8List.fromList(secretString.codeUnits);
  // encryptionCipher: HiveAesCipher(secret)
  try {
    final box = await Hive.openBox('$_boxName');
    print(box.isOpen);
//    box.keys.forEach((element) async {
//      if(element.toString().startsWith('public:')) {
//        print(await box.get(element));
//      }
//      });
    for(int i=0;i<10;i++) {
      await box.put(i, i);
    }

    for(int i=0;i<6;i++) {
      await box.delete(i);
    }
//    await box.put('444', 'hello4');
  } on HiveError catch(err,trace) {
      print(err.message);
      print(trace);
  }
  sleep(Duration(seconds: 15));


}